#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
using namespace std;

struct Input{
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& in, bool promt)
{
    if (promt){
        size_t number_count;
        cerr << "Enter number count: ";
        in >> number_count;

        Input In;

        In.numbers.resize(number_count);
        cerr << "Enter numbers: ";
        for(size_t i = 0; i < number_count; i++){
            in >> In.numbers[i];
        }

        cerr << "Enter bin count: ";
        in >> In.bin_count;
        return In;
    }
    else{
        size_t number_count;
        in >> number_count;

        Input In;

        In.numbers.resize(number_count);
        for(size_t i = 0; i < number_count; i++){
            in >> In.numbers[i];
        }

        in >> In.bin_count;
        return In;
    }
}

int main()
{
    auto in = input_data(cin,false);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
    return 0;
}
